import brewman.schemas.account_type as schemas

from fastapi import APIRouter, Depends

from ..core.security import get_current_active_user as get_user
from ..models.voucher_type import VoucherType
from ..schemas.user import UserToken


router = APIRouter()


@router.get("", response_model=list[schemas.AccountType])
def account_type_list(user: UserToken = Depends(get_user)) -> list[schemas.AccountType]:
    return [schemas.AccountType(id_=item.value, name=item.name) for item in list(VoucherType)]
