import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { BalanceSheetResolver } from './balance-sheet-resolver.service';
import { BalanceSheetComponent } from './balance-sheet.component';

const balanceSheetRoutes: Routes = [
  {
    path: '',
    component: BalanceSheetComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Balance Sheet',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(BalanceSheetResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':date',
    component: BalanceSheetComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Balance Sheet',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(BalanceSheetResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(balanceSheetRoutes)],
  exports: [RouterModule],
  providers: [BalanceSheetResolver],
})
export class BalanceSheetRoutingModule {}
