import { CashFlowItem } from './cash-flow-item';

export class CashFlow {
  startDate: string;
  finishDate: string;
  body: {
    operating: CashFlowItem[];
    investing: CashFlowItem[];
    financing: CashFlowItem[];
    details: CashFlowItem[];
  };

  footer: CashFlowItem[];

  public constructor(init?: Partial<CashFlow>) {
    this.startDate = '';
    this.finishDate = '';
    this.body = {
      operating: [],
      investing: [],
      financing: [],
      details: [],
    };
    this.footer = [];
    Object.assign(this, init);
  }

  static Data(value: CashFlow): CashFlowItem[] {
    const d: CashFlowItem[] = [];
    if (value.body.operating?.length) {
      d.push(new CashFlowItem({ name: 'Cash flows from Operating activities' }));
      d.push(...value.body.operating);
    }
    if (value.body.investing?.length) {
      d.push(new CashFlowItem({ name: 'Cash flows from Investing activities' }));
      d.push(...value.body.investing);
    }
    if (value.body.financing?.length) {
      d.push(new CashFlowItem({ name: 'Cash flows from Financing activities' }));
      d.push(...value.body.financing);
    }
    if (value.body.details?.length) {
      d.push(...value.body.details);
    }
    return d;
  }
}
