import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { DaybookResolver } from './daybook-resolver.service';
import { DaybookComponent } from './daybook.component';

const daybookRoutes: Routes = [
  {
    path: '',
    component: DaybookComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Daybook',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(DaybookResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(daybookRoutes)],
  exports: [RouterModule],
  providers: [DaybookResolver],
})
export class DaybookRoutingModule {}
