import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { JournalResolver } from './journal-resolver.service';
import { JournalComponent } from './journal.component';

const journalRoutes: Routes = [
  {
    path: '',
    component: JournalComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Journal',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(JournalResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: JournalComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Journal',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(JournalResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(journalRoutes)],
  exports: [RouterModule],
  providers: [JournalResolver],
})
export class JournalRoutingModule {}
