import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { ProductLedgerResolver } from './product-ledger-resolver.service';
import { ProductLedgerComponent } from './product-ledger.component';

const productLedgerRoutes: Routes = [
  {
    path: '',
    component: ProductLedgerComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Product Ledger',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(ProductLedgerResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: ProductLedgerComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Product Ledger',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(ProductLedgerResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(productLedgerRoutes)],
  exports: [RouterModule],
  providers: [ProductLedgerResolver],
})
export class ProductLedgerRoutingModule {}
