import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { PurchaseReturnResolver } from './purchase-return-resolver.service';
import { PurchaseReturnComponent } from './purchase-return.component';

const purchaseReturnRoutes: Routes = [
  {
    path: '',
    component: PurchaseReturnComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Purchase Return',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(PurchaseReturnResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: PurchaseReturnComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Purchase Return',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(PurchaseReturnResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(purchaseReturnRoutes)],
  exports: [RouterModule],
  providers: [PurchaseReturnResolver],
})
export class PurchaseReturnRoutingModule {}
