import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Voucher } from '../core/voucher';
import { VoucherService } from '../core/voucher.service';

@Injectable({
  providedIn: 'root',
})
export class PurchaseResolver {
  constructor(private ser: VoucherService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Voucher> {
    const id = route.paramMap.get('id');
    if (id === null) {
      return this.ser.getOfType('Purchase');
    }
    return this.ser.get(id, 'Purchase');
  }
}
