import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { PurchaseResolver } from './purchase-resolver.service';
import { PurchaseComponent } from './purchase.component';

const purchaseRoutes: Routes = [
  {
    path: '',
    component: PurchaseComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Purchase',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(PurchaseResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: PurchaseComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Purchase',
    },
    resolve: {
      voucher: (route: ActivatedRouteSnapshot) => inject(PurchaseResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(purchaseRoutes)],
  exports: [RouterModule],
  providers: [PurchaseResolver],
})
export class PurchaseRoutingModule {}
