import { Injectable } from '@angular/core';
import { evaluate, round } from 'mathjs';

@Injectable({
  providedIn: 'root',
})
export class MathService {
  journalAmount(amount = '', debit: number): { debit: number; amount: number } {
    const val = this.parseAmount(amount, 2);
    let newDebit = debit;
    if (val < 0) {
      newDebit *= -1;
    }
    return { debit: newDebit, amount: Math.abs(val) };
  }

  parseAmount(amount = '', rounding = 2): number {
    const cleaned = `${amount}`.replace(new RegExp('(₹[s]*)|(,)|(s)', 'g'), '');
    if (cleaned === '') {
      return 0;
    }
    return round(evaluate(cleaned), rounding);
  }
}
